//
//  mdlInspectionCategory.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlInspectionCategory: Model, Content {
    static let schema = "inspectionCategory"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Parent(key: "inspectionId") var inspection: mdlInspection
    @Parent(key: "categoryId") var category: mdlCategory
    @Field(key: "summary") var summary: String?
    
    @Children(for: \.$category) var inspectionitems: [mdlInspectionItem]
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         inspectionid: Int,
         categoryid: Int,
         summary: String? = nil,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.$inspection.$id.value = inspectionid
        self.$category.$id.value = categoryid
        self.summary = summary
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlInspectionCategory{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("inspectionCategory")
                .field("id", .int, .identifier(auto: true))
                .field("isnpectionId", .int, .references("inspection", "id"))
                .field("categoryId", .int, .references("category", "id"))
                .field("summary", .string)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("inspectionCategory").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlInspectionCategory>{
        
        let query = mdlInspectionCategory.query(on: req.db)
            .with(\.$inspection)
            .with(\.$category)
            .with(\.$inspectionitems)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

